%define section devel
%define base_name proxool

Summary:        Proxool Java connection pool
Name:           %{base_name}
Version:        0.8.3
Release:        7jpp
Epoch:          0
License:        Open Source
URL:            http://proxool.sourceforge.net/
Group:          Development/Libraries/Java
Vendor:         JPackage Project
Distribution:   JPackage
Source0:        proxool-0.8.3-source.tar.gz
Patch0:         proxool-hsqldb-1.72.patch
# activate this patch if hibernate not yet available
#Patch1:         proxool-bootstrap-HibernateTest.patch
BuildRequires:  jpackage-utils >= 0:1.5
BuildRequires:  ant >= 0:1.6
BuildRequires:  ant-junit
BuildRequires:  avalon-excalibur
BuildRequires:  avalon-framework
BuildRequires:  avalon-logkit
BuildRequires:  cglib
BuildRequires:  checkstyle
BuildRequires:  jakarta-commons-collections
BuildRequires:  jakarta-commons-lang
BuildRequires:  jakarta-commons-logging
BuildRequires:  crimson
BuildRequires:  dom4j
# activate hibernate if available
# see proxool-bootstrap-HibernateTest.patch
BuildRequires:  hibernate >= 0:2.1.4
BuildRequires:  hsqldb >= 0:1.72
BuildRequires:  jaxen >= 0:1.1
BuildRequires:  jdbc-stdext
BuildRequires:  jta
BuildRequires:  junit
BuildRequires:  log4j
BuildRequires:  mx4j
BuildRequires:  servletapi4
BuildRequires:  xalan-j2
BuildRequires:  xml-commons-apis
Requires:  /usr/sbin/update-alternatives
Requires:  avalon-excalibur
Requires:  avalon-framework
Requires:  avalon-logkit
Requires:  cglib
Requires:  checkstyle
Requires:  jakarta-commons-collections
Requires:  jakarta-commons-lang
Requires:  jakarta-commons-logging
Requires:  crimson
Requires:  dom4j
Requires:  hibernate >= 0:2.1.4
Requires:  hsqldb >= 0:1.72
Requires:  jaxen >= 0:1.1
Requires:  jdbc-stdext
Requires:  jta
Requires:  log4j
Requires:  mx4j
Requires:  servletapi4
Requires:  xalan-j2
Requires:  xml-commons-apis
Provides:  hibernate_jdbc_cache
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-buildroot

%description
Transparently adds connection pooling to 
your existing JDBC driver.  Our licence 
allows you flexibility to use it in both 
commerical and other open source products.
Complies with the J2SE API, giving you the 
confidence to develop to standards. You can 
monitor the performance of your database 
connections and listen to connection events.
It's easy to configure using the JDBC API, 
XML, or Java property files - you decide.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
%{summary}.

%package manual
Summary:        Documents for %{name}
Group:          Development/Documentation

%description manual
%{summary}.

%prep
%setup -q -n %{base_name}-%{version}
find . -name "*.jar" -exec rm {} \;
# activate this rm if hibernate not yet available
# rm src/java-test/org/logicalcobwebs/proxool/HibernateTest.java
echo >> src/java-test/org/logicalcobwebs/proxool/ProxyStatementTest.java

%patch0
# activate this patch if hibernate not yet available
# %patch1

%build
(cd lib
ln -s $(find-jar avalon-excalibur) avalon-excalibur.jar
ln -s $(find-jar avalon-framework) avalon-framework.jar
ln -s $(find-jar avalon-logkit) avalon-logkit.jar
ln -s $(find-jar cglib) cglib.jar
ln -s $(find-jar checkstyle) checkstyle.jar
ln -s $(find-jar commons-collections) commons-collections.jar
ln -s $(find-jar commons-lang) commons-lang.jar
ln -s $(find-jar commons-logging) commons-logging.jar
ln -s $(find-jar crimson) crimson.jar
ln -s $(find-jar dom4j) dom4j.jar
ln -s $(find-jar ehcache) ehcache.jar
ln -s $(find-jar hibernate) hibernate.jar
ln -s $(find-jar hsqldb) hsqldb.jar
ln -s $(find-jar jaxen) jaxen.jar
ln -s $(find-jar jdbc-stdext) jdbc-stdext.jar
ln -s $(find-jar jta) jta.jar
ln -s $(find-jar junit) junit.jar
ln -s $(find-jar log4j) log4j.jar
ln -s $(find-jar mx4j/mx4j-jmx) mx4j-jmx.jar
ln -s $(find-jar servletapi4) servletapi4.jar
ln -s $(find-jar xalan-j2) xalan-j2.jar
ln -s $(find-jar xml-commons-apis) xml-commons-apis.jar
)
export CLASSPATH=
ant -Dtest=true test build-jar

%install
rm -rf $RPM_BUILD_ROOT

# jars
mkdir -p $RPM_BUILD_ROOT%{_javadir}
cp -p build/%{base_name}-%{version}.jar \
      $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar
(cd $RPM_BUILD_ROOT%{_javadir} && for jar in *-%{version}.jar; do ln -sf ${jar} `echo $jar| sed "s|-%{version}||g"`; done)

# javadoc
mkdir -p $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr doc/api/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink
rm -rf doc/api
rm -rf doc/api-dev

#manual
mkdir -p $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
cp -pr doc/* $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
cp *.txt $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}

# hibernate_jdbc_cache ghost symlink
ln -s %{_sysconfdir}/alternatives \
  $RPM_BUILD_ROOT%{_javadir}/hibernate_jdbc_cache.jar


%clean
rm -rf $RPM_BUILD_ROOT

%post
update-alternatives --install %{_javadir}/hibernate_jdbc_cache.jar \
  hibernate_jdbc_cache %{_javadir}/%{name}.jar 40

%preun
{
  [ $1 -eq 0 ] || exit 0
  update-alternatives --remove hibernate_jdbc_cache %{_javadir}/%{name}.jar
} >/dev/null 2>&1 || :

%post javadoc
rm -f %{_javadocdir}/%{name}
ln -s %{name}-%{version} %{_javadocdir}/%{name}

%postun javadoc
if [ "$1" = "0" ]; then
  rm -f %{_javadocdir}/%{name}
fi

%files
%defattr(0644,root,root,0755)
%doc %{_docdir}/%{name}-%{version}/LICENCE.txt
%{_javadir}/*.jar
%ghost %{_javadir}/hibernate_jdbc_cache.jar

%files javadoc
%defattr(0644,root,root,0755)
%doc %{_javadocdir}/%{name}-%{version}
%ghost %doc %{_javadocdir}/%{name}

%files manual
%defattr(0644,root,root,0755)
%doc %{_docdir}/%{name}-%{version}

%changelog
* Mon Sep 13 2004 Ralph Apel <r.apel at r-apel.de> - 0:0.8.3-7jpp
- Drop saxpath requirements
- Require jaxen >= 0:1.1

* Wed Aug 25 2004 Fernando Nasser <fnasser@redhat.com> - 0:0.8.3-6jpp
- Rebuild with Ant 1.6.2

* Fri Aug 06 2004 Ralph Apel <r.apel at r-apel.de> - 0:0.8.3-5jpp
- Upgrade to require ant >= 0:1.6

* Fri Jul 02 2004 Ralph Apel <r.apel at r-apel.de> - 0:0.8.3-4jpp
- Relax some versioned dependencies
- Provide hibernate_jdbc_cache and do update-alternatives, prio 40

* Fri Jun 11 2004 Ralph Apel <r.apel at r-apel.de> - 0:0.8.3-3jpp
- adapt to hsqldb-1.72
- build with hibernate-2.1.4

* Wed Apr 07 2004 Ralph Apel <r.apel at r-apel.de> - 0:0.8.3-2jpp
- _javadir ownership correction thanks to Kaj J. Niemi

* Tue Mar 09 2004 Ralph Apel <r.apel at r-apel.de> - 0:0.8.3-1jpp
- First JPackage release
